/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucChanTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents:   This file contains :
 *                  1)  Include files
 *                  2)  User defined data types
 *                  3)  Function proto-types for adslAtucChanTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
//#include <adslMIBincl.h>


#ifndef ADSLATUCCHANTABLE_ACCESS_H
#define ADSLATUCCHANTABLE_ACCESS_H
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAtucChanTable **/
typedef struct adslAtucChanInfo {
    int ifIndex;
    u_int32 interleaveDelay;
    u_int32 currTxRate;
    u_int32 prevTxRate;
    u_char flags;
} adslAtucChanInfo;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/** User-defined data access functions for data in table adslAtucChanTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAtucChanTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucChanTable_get_next_data_point;

/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32         *
get_adslAtucChanInfo(void *data_context, size_t * ret_len,
		unsigned int var);
#else
u_int32 *get_adslAtucChanInterleaveDelay(void *data_context, size_t * ret_len);
u_int32 *get_adslAtucChanCurrTxRate(void *data_context, size_t * ret_len);
u_int32 *get_adslAtucChanPrevTxRate(void *data_context, size_t * ret_len);
#endif

#ifndef ENABLE_DRIVER_CALL
int  get_adslAtucChanTable(int Fd2,int GET_ADSL_atuc_CHAN_INFO,
        void *adslAtucChanTable);
#endif

#endif                          /* ADSLATUCCHANTABLE_ACCESS_H */
