/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslLineAlarmConfProfileTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslLineAlarmConfProfileTable
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 * Subramani: Changed data types as per Rfc-2662
 * $Log$
 * ===========================================================================
 */


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
#ifndef ADSLLINEALARMCONFPROFILETABLE_ACCESS_H
#define ADSLLINEALARMCONFPROFILETABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

#ifdef STUB_IOCTL
/* Data structures */

typedef struct  adslLineAlarmConfProfileEntry
 {
  unsigned char adslLineAlarmConfProfileName[32];
    int     adslAtucThresh15MinLofs;
    int     adslAtucThresh15MinLoss;
    int     adslAtucThresh15MinESs;
    u_int32     adslAtucThreshFastRateUp;
    u_int32     adslAtucThreshInterleaveRateUp;
    u_int32     adslAtucThreshFastRateDown;
    u_int32     adslAtucThreshInterleaveRateDown;
    int     adslAtucInitFailureTrapEnable;
    int     adslAturThresh15MinLofs;
    int     adslAturThresh15MinLoss;
    int     adslAturThresh15MinLprs;
    int     adslAturThresh15MinESs;
    u_int32     adslAturThreshFastRateUp;
    u_int32     adslAturThreshInterleaveRateUp;
    u_int32     adslAturThreshFastRateDown;
    u_int32     adslAturThreshInterleaveRateDown;
    int     adslLineAlarmConfProfileRowStatus;
    u_int32 flags;
} adslLineAlarmConfProfileEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/


/** User-defined data access functions for data in table
    adslLineAlarmConfProfileTable */
/** row level accessors */
Netsnmp_First_Data_Point adslLineAlarmConfProfileTable_get_first_data_point;
Netsnmp_Next_Data_Point adslLineAlarmConfProfileTable_get_next_data_point;

int             adslLineAlarmConfProfileTable_commit_row(void
                                                         **my_data_context,
                                                         int new_or_del);
void
    *adslLineAlarmConfProfileTable_create_data_context
    (netsnmp_variable_list * index_data);

/** column accessors */
  
#if defined(HAVE_OPTIMIZED_CODE)
int *
get_adslThresh15MinVal(void *data_context, size_t *ret_len, unsigned int var);

int 
set_adslThresh15MinVal(void *data_context, long *val, 
		size_t val_len, unsigned int var);

u_int32         *
get_adslThreshChanVal(void *data_context, size_t *ret_len, unsigned int var);

int 
set_adslThreshChanVal(void *data_context, long *val, 
		size_t val_len, unsigned int var);
#else

int           *get_adslAtucThresh15MinLofs(void *data_context,
                                            size_t * ret_len);
int             set_adslAtucThresh15MinLofs(void *data_context, long *val,
                                            size_t val_len);
int           *get_adslAtucThresh15MinLoss(void *data_context,
                                            size_t * ret_len);
int             set_adslAtucThresh15MinLoss(void *data_context, long *val,
                                            size_t val_len);

int           *get_adslAtucThresh15MinESs(void *data_context,
                                           size_t * ret_len);
int             set_adslAtucThresh15MinESs(void *data_context, long *val,
                                           size_t val_len);
u_int32         *get_adslAtucThreshFastRateUp(void *data_context,
                                             size_t * ret_len);
int             set_adslAtucThreshFastRateUp(void *data_context,
                                             u_long * val, size_t val_len);
u_int32         *get_adslAtucThreshInterleaveRateUp(void *data_context,
                                                   size_t * ret_len);
int             set_adslAtucThreshInterleaveRateUp(void *data_context,
                                                   u_long * val,
                                                   size_t val_len);
u_int32         *get_adslAtucThreshFastRateDown(void *data_context,
                                               size_t * ret_len);
int             set_adslAtucThreshFastRateDown(void *data_context,
                                               u_long * val,
                                               size_t val_len);
u_int32         *get_adslAtucThreshInterleaveRateDown(void *data_context,
                                                     size_t * ret_len);
int             set_adslAtucThreshInterleaveRateDown(void *data_context,
                                                     u_long * val,
                                                     size_t val_len);
int           *get_adslAtucInitFailureTrapEnable(void *data_context,
                                                  size_t * ret_len);
int             set_adslAtucInitFailureTrapEnable(void *data_context,
                                                  long *val,
                                                  size_t val_len);
int           *get_adslAturThresh15MinLofs(void *data_context,
                                            size_t * ret_len);
int             set_adslAturThresh15MinLofs(void *data_context, long *val,
                                            size_t val_len);
int           *get_adslAturThresh15MinLoss(void *data_context,
                                            size_t * ret_len);
int             set_adslAturThresh15MinLoss(void *data_context, long *val,
                                            size_t val_len);
int           *get_adslAturThresh15MinLprs(void *data_context,
                                            size_t * ret_len);
int             set_adslAturThresh15MinLprs(void *data_context, long *val,
                                            size_t val_len);
int           *get_adslAturThresh15MinESs(void *data_context,
                                           size_t * ret_len);
int             set_adslAturThresh15MinESs(void *data_context, long *val,
                                           size_t val_len);
u_int32         *get_adslAturThreshFastRateUp(void *data_context,
                                             size_t * ret_len);
int             set_adslAturThreshFastRateUp(void *data_context,
                                             u_long * val, size_t val_len);
u_int32         *get_adslAturThreshInterleaveRateUp(void *data_context,
                                                   size_t * ret_len);
int             set_adslAturThreshInterleaveRateUp(void *data_context,
                                                   u_long * val,
                                                   size_t val_len);
u_int32         *get_adslAturThreshFastRateDown(void *data_context,
                                               size_t * ret_len);
int             set_adslAturThreshFastRateDown(void *data_context,
                                               u_long * val,
                                               size_t val_len);
u_int32         *get_adslAturThreshInterleaveRateDown(void *data_context,
                                                     size_t * ret_len);
int             set_adslAturThreshInterleaveRateDown(void *data_context,
                                                     u_long * val,
                                                     size_t val_len);
int           *get_adslLineAlarmConfProfileRowStatus(void *data_context,
                                                      size_t * ret_len);
int             set_adslLineAlarmConfProfileRowStatus(void *data_context,
                                                      long *val,
                                                      size_t val_len);
#endif

#ifndef ENABLE_DRIVER_CALL
int adslLineAlarmConfProfileTable(int Fd2, int ADSL_ALRM_CONF_PROF2,
                    void *adslLineAlarmStruct);
#endif


#endif                          /* ADSLLINEALARMCONFPROFILETABLE_ACCESS_H */
