/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : bwQueue_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.8 2004/10/14 12:57:34 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/watcher.h>
#include "bwQueue_access.h"

static IFX_MIB_ENUM_S qos_Port_Enum[3] =
{
    {0, "lan"},
    {1, "pc"},
    {2, "ipp"}
};

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
//extern IFX_MIB_ENUM_S qos_Port_Enum[3];

static oid      bwQueueL2_oid[] =
                        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 4, 1, 1, 0 };
static oid      bwQueueL3_oid[] =
                        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 4, 1, 2, 0 };
static oid      bwQueueL2OrL3_oid[] =
                        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 4, 1, 3, 0 };
static oid      bwQueuePolicy_oid[] =
                        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 4, 1, 4, 0 };
static oid      bwQueueAssign_oid[] =
                        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 4, 1, 5, 0 };

static char                 cTag[MAX_TAG_LEN];
static char                 cRetVal[MAX_DATA_LEN];
static char                 cQueueL2[3];
static char                 cQueueL3[17];
static int                  nQueueL2OrL3 = 0;
static int                  nQueuePolicy = 0;
static int                  nQueueAssign = 0;
netsnmp_helper_info         winfo;

void *
bwQueue_create_context()
{
    memset (&cRetVal, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "mapping_table", "layer2",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueueL2: unable get cQueueL2\n");
	}
	strcpy (cQueueL2, cRetVal);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "mapping_table", "layer3",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueueL3: unable get cQueueL3\n");
	}
	strcpy (cQueueL3, cRetVal);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "diff_priorities", "diff_pri",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueueL2OrL3: unable get nQueueL2OrL3\n");
	}
	nQueueL2OrL3 = atoi(cRetVal);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "handling_que_priority", "hdl_pri",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueuePolicy: unable get nQueuePolicy\n");
	}
	nQueuePolicy = atoi(cRetVal);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "port_priority", "port_priority_status",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueueAssign: unable get nQueueAssign\n");
	}
	nQueueAssign = atoi(cRetVal);
}

int
check_bwQueueL2(int type, char *val, size_t val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len > 2)
    {
        snmp_log(LOG_ERR, "bwQueueL2: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (ifx_strToHex(val) < 0)
    {
        snmp_log(LOG_ERR, "bwQueueL2: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

int
check_bwQueueL3(int type, char *val, size_t val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len < 1 || val_len > 16)
    {
        snmp_log(LOG_ERR, "bwQueueL3: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }
    
    if (ifx_strToHex(val) < 0)
    {
        snmp_log(LOG_ERR, "bwQueueL3: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}


/** Decides if an incoming value for the bwQueueL2OrL3 mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwQueueL2OrL3(int type, int *val, size_t val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == LAYER2_PRIORITY ||
          *val == LAYER3_PRIORITY) )
    {
        snmp_log(LOG_ERR, "bwQueueL2OrL3: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the bwQueuePolicy mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwQueuePolicy(int type, int *val, size_t val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == STRICT_POLICY ||
          *val == FAIR_POLICY) )
    {
        snmp_log(LOG_ERR, "bwQueuePolicy: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the bwQueueAssign mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_bwQueueAssign(int type, int *val, size_t val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == QUEUE_ASSIGN_NO ||
          *val == QUEUE_ASSIGN_YES) )
    {
        snmp_log(LOG_ERR, "bwQueueAssign: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

int
A_do_bwQueueL2_L3(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        char    sL2[MAX_DATA_LEN], sL3[MAX_DATA_LEN];
        int     ret = -1;
        int     nSetReturn = -1;

        if (snmp_oid_compare(requests->requestvb->name,
                             requests->requestvb->name_length,
                             bwQueueL2_oid,
                             OID_LENGTH(bwQueueL2_oid)) == 0)
        {
            ret = check_bwQueueL2(requests->requestvb->type,
                                  requests->requestvb->val.string,
                                  requests->requestvb->val_len);
        }
        else
        if (snmp_oid_compare(requests->requestvb->name,
                             requests->requestvb->name_length,
                             bwQueueL3_oid,
                             OID_LENGTH(bwQueueL3_oid)) == 0)
        {
            ret = check_bwQueueL3(requests->requestvb->type,
                                  requests->requestvb->val.string,
                                  requests->requestvb->val_len);
        }

        if (ret < 0)
        {
            netsnmp_set_request_error(reqinfo, requests, ret);
        }
        else
        {
            /* Queue Layer 2 */
            memset (&sL2, 0x00, MAX_DATA_LEN);
            sprintf (sL2, "layer2=\"%s\"\n", cQueueL2);

            /* Queue Layer 3 */
            memset (&sL3, 0x00, MAX_DATA_LEN);
            sprintf (sL3, "layer3=\"%s\"\n", cQueueL3);

            nSetReturn = websSetCfgData(FILE_RC_CONF, "mapping_table", 2,
                                        sL2, sL3);

            if (nSetReturn != 1)
            {
                return SNMP_ERR_COMMITFAILED;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        bwQueue_create_context();
        memset (&winfo, 0x00, sizeof(netsnmp_helper_info));

        if (snmp_oid_compare(requests->requestvb->name,
                             requests->requestvb->name_length,
                             bwQueueL2_oid,
                             OID_LENGTH(bwQueueL2_oid)) == 0)
        {
            winfo.data      = (void *)&cQueueL2;
            winfo.data_size = strlen(cQueueL2);
            winfo.type      = ASN_OCTET_STR;
            winfo.flags     = HELPER_FIXED_SIZE;
            winfo.max_size  = strlen(cQueueL2);
        }
        else
        if (snmp_oid_compare(requests->requestvb->name,
                             requests->requestvb->name_length,
                             bwQueueL3_oid,
                             OID_LENGTH(bwQueueL3_oid)) == 0)
        {
            winfo.data      = (void *)&cQueueL3;
            winfo.data_size = strlen(cQueueL3);
            winfo.type      = ASN_OCTET_STR;
            winfo.flags     = HELPER_FIXED_SIZE;
            winfo.max_size  = strlen(cQueueL3);
        }

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}

int
A_do_bwQueueL2OrL3(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        char    sTemp[MAX_DATA_LEN];
        int     ret = -1;
        int     nSetReturn = -1;

        ret = check_bwQueueL2OrL3(requests->requestvb->type,
                                  (int *)requests->requestvb->val.string,
                                  requests->requestvb->val_len);

        if (ret < 0)
        {
            netsnmp_set_request_error(reqinfo, requests, ret);
        }
        else
        {
            /* Queue Layer2 or Layer3 */
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf (sTemp, "diff_pri=\"%d\"\n", nQueueL2OrL3);

            nSetReturn = websSetCfgData(FILE_RC_CONF, "diff_priorities", 1, sTemp);

            if (nSetReturn != 1)
            {
                return SNMP_ERR_COMMITFAILED;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        bwQueue_create_context();
        memset (&winfo, 0x00, sizeof(netsnmp_helper_info));
        winfo.data      = (void *)&nQueueL2OrL3;
        winfo.data_size = sizeof(nQueueL2OrL3);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = LAYER3_PRIORITY;
        winfo.min_size  = LAYER2_PRIORITY;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}

int
A_do_bwQueuePolicy(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        char    sTemp[MAX_DATA_LEN];
        int     ret = -1;
        int     nSetReturn = -1;

        ret = check_bwQueuePolicy(requests->requestvb->type,
                                  (int *)requests->requestvb->val.string,
                                  requests->requestvb->val_len);

        if (ret < 0)
        {
            netsnmp_set_request_error(reqinfo, requests, ret);
        }
        else
        {
            /* Queue Policy */
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf (sTemp, "hdl_pri=\"%d\"\n", nQueuePolicy);

            nSetReturn = websSetCfgData(FILE_RC_CONF, "handling_que_priority",
                                        1, sTemp);

            if (nSetReturn != 1)
            {
                return SNMP_ERR_COMMITFAILED;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        bwQueue_create_context();
        memset (&winfo, 0x00, sizeof(netsnmp_helper_info));
        winfo.data      = (void *)&nQueuePolicy;
        winfo.data_size = sizeof(nQueuePolicy);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = FAIR_POLICY;
        winfo.min_size  = STRICT_POLICY;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}
int
A_do_bwQueueAssign(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        char    sBuf[BUF_SIZE_1K];
        char    sTemp[MAX_DATA_LEN];
        int     i = 0;
        int     ret = -1;
        int     nSetReturn = -1;

        ret = check_bwQueueAssign(requests->requestvb->type,
                                  (int *)requests->requestvb->val.string,
                                  requests->requestvb->val_len);

        if (ret < 0)
        {
            netsnmp_set_request_error(reqinfo, requests, ret);
        }
        else
        {
            memset (&sBuf, 0x00, BUF_SIZE_1K);

            for (i = 0; i < sizeof(qos_Port_Enum)/sizeof(IFX_MIB_ENUM_S); i++)
            {
                memset (&sTemp, 0x00, MAX_DATA_LEN);
                memset (&cTag, 0x00, MAX_TAG_LEN);
                memset (&cRetVal, 0x00, MAX_DATA_LEN);
                sprintf(cTag, "%s_port", qos_Port_Enum[i].str);
            	if (ifx_GetCfgData(FILE_RC_CONF, "port_priority", cTag,
            	                   cRetVal) != 1)
            	{
                    snmp_log(LOG_ERR, "Port Priority: unable to get "
                                      "Port Priority\n");
            	}
            	sprintf(sTemp, "%s=\"%s\"\n", cTag, cRetVal);
            	strcat (sBuf, sTemp);
            }

            /* Queue Assign */
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf (sTemp, "port_priority_status=\"%d\"\n", nQueueAssign);

            nSetReturn = websSetCfgData(FILE_RC_CONF, "port_priority",
                                        2, sTemp, sBuf);

            if (nSetReturn != 1)
            {
                return SNMP_ERR_COMMITFAILED;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        bwQueue_create_context();
        memset (&winfo, 0x00, sizeof(netsnmp_helper_info));
        winfo.data      = (void *)&nQueueAssign;
        winfo.data_size = sizeof(nQueueAssign);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = QUEUE_ASSIGN_YES;
        winfo.min_size  = QUEUE_ASSIGN_NO;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}

/** Initializes the bwQueueL2 module */
void
init_bwQueue(void)
{
    DEBUGMSGTL(("bwQueue", "Initializing\n"));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("bwQueueL2", A_do_bwQueueL2_L3, bwQueueL2_oid,
                             OID_LENGTH(bwQueueL2_oid),
                             HANDLER_CAN_RWRITE));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("bwQueueL3", A_do_bwQueueL2_L3, bwQueueL3_oid,
                             OID_LENGTH(bwQueueL3_oid),
                             HANDLER_CAN_RWRITE));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("bwQueueL2OrL3", A_do_bwQueueL2OrL3,
                             bwQueueL2OrL3_oid,
                             OID_LENGTH(bwQueueL2OrL3_oid),
                             HANDLER_CAN_RWRITE));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("bwQueuePolicy", A_do_bwQueuePolicy,
                             bwQueuePolicy_oid,
                             OID_LENGTH(bwQueuePolicy_oid),
                             HANDLER_CAN_RWRITE));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("bwQueueAssign", A_do_bwQueueAssign,
                             bwQueueAssign_oid,
                             OID_LENGTH(bwQueueAssign_oid),
                             HANDLER_CAN_RWRITE));

    bwQueue_create_context();
}
