/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.7 2003/04/08 14:57:04 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/watcher.h>
#include "ifxStunMIB_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static int                  nStunStatus = IFX_CM_OFF;
static char                 cStunServerAddr[MAX_IP_ADDRESS];
static int                  nStunPort = 0;
static x_IFX_CM_Msg         g_xCmMsg;
netsnmp_helper_info        winfo;

void *
ifxStun_create_context()
{
    memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));
    memset (&cStunServerAddr, 0x00, MAX_IP_ADDRESS);

    /* Get Data from CM */
    g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;		
    g_xCmMsg.ucChannel = 0;
    
    if (IFX_CM_RecvDataFromCM(&g_xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR, "ifxStun: Fail to receive data from CM\n");
    }

    nStunStatus = g_xCmMsg.uxData.xStunCfg.ucFlag;
    strcpy (cStunServerAddr, g_xCmMsg.uxData.xStunCfg.acStunServer);
    nStunPort = g_xCmMsg.uxData.xStunCfg.unPort;
}

/** Initializes the ifxStunMIB module */
void
init_ifxStunMIB(void)
{
    static oid      ifxStunStatus_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 3, 1, 0 };
    static oid      ifxStunServerAddr_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 3, 2, 0 };
    static oid      ifxStunPort_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 3, 3, 0 };

    DEBUGMSGTL(("ifxStunMIB", "Initializing\n"));

    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("ifxStunStatus", A_do_ifxStunStatus,
                             ifxStunStatus_oid,
                             OID_LENGTH(ifxStunStatus_oid),
                             HANDLER_CAN_RWRITE));
    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("ifxStunServerAddr", A_do_ifxStunServerAddr,
                             ifxStunServerAddr_oid,
                             OID_LENGTH(ifxStunServerAddr_oid),
                             HANDLER_CAN_RWRITE));
    netsnmp_register_instance(netsnmp_create_handler_registration
                            ("ifxStunPort", A_do_ifxStunPort,
                             ifxStunPort_oid, OID_LENGTH(ifxStunPort_oid),
                             HANDLER_CAN_RWRITE));

    ifxStun_create_context();
}

int
A_do_ifxStunPort(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        if (nStunStatus == IFX_CM_ON)
        {
            /* Populate the structure of CM*/
            memset(&g_xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
            g_xCmMsg.ucChannel = 0;  /* For port 1*/ 
        	
            /* Get original data from CM */
            if (IFX_CM_RecvDataFromCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxStunPort: Fail to receive data from CM\n");
                return SNMP_ERR_GENERR;
            }

            /* Populate the structure of CM*/
            g_xCmMsg.uxData.xStunCfg.unPort = nStunPort;
            g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
            g_xCmMsg.ucChannel = 0;

            if (IFX_CM_SendDataToCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxStunPort: Cant send Data to CM.\n");
                return SNMP_ERR_GENERR;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        ifxStun_create_context();
        winfo.data      = (void *)&nStunPort;
        winfo.data_size = sizeof(nStunPort);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = 65535;
        winfo.min_size  = 0;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}

int
A_do_ifxStunStatus(netsnmp_mib_handler *handler,
                     netsnmp_handler_registration *reginfo,
                     netsnmp_agent_request_info *reqinfo,
                     netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        /* Populate the structure of CM*/
        memset(&g_xCmMsg, 0, sizeof(x_IFX_CM_Msg));
        g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
        g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
        g_xCmMsg.ucChannel = 0;  /* For port 1*/ 
    	
        /* Get original data from CM */
        if (IFX_CM_RecvDataFromCM(&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR, "ifxStunStatus: Fail to receive data from CM\n");
            return SNMP_ERR_GENERR;
        }

        /* Populate the structure of CM*/
        g_xCmMsg.uxData.xStunCfg.ucFlag = nStunStatus;
        g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
        g_xCmMsg.ucChannel = 0;
        g_xCmMsg.uxData.xStunCfg.iNatType = IFX_CM_NAT_TYPE_NONAT;

        if (IFX_CM_SendDataToCM(&g_xCmMsg) != IFX_CM_SUCCESS)
        {
        	snmp_log(LOG_ERR, "ifxStunStatus: Cant send Data to CM.\n");
            return SNMP_ERR_GENERR;
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        ifxStun_create_context();
        winfo.data      = (void *)&nStunStatus;
        winfo.data_size = sizeof(nStunStatus);
        winfo.type      = ASN_INTEGER;
        winfo.flags     = HELPER_CHECK_MAX_MIN;
        winfo.max_size  = IFX_CM_ON;
        winfo.min_size  = IFX_CM_OFF;

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}

int
A_do_ifxStunServerAddr(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{
    if (reqinfo->mode == MODE_SET_COMMIT)
    {
        if (nStunStatus == IFX_CM_ON)
        {
            /* Populate the structure of CM*/
            memset(&g_xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
            g_xCmMsg.ucChannel = 0;  /* For port 1*/ 
        	
            /* Get original data from CM */
            if (IFX_CM_RecvDataFromCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxStunServerAddr: Fail to receive data from CM\n");
                return SNMP_ERR_GENERR;
            }

            /* Populate the structure of CM*/
            strcpy (cStunServerAddr, requests->requestvb->val.string);

            /* Validation */      
            if (IFX_ValidateIpAddress(&cStunServerAddr) < 0)
            {
                snmp_log(LOG_ERR, "Invalid Stun IP address!!!.<br>"
                               "'Either all the numbers are not entered or "
                               "some of the entered numbers are invalid."
                               "<br>The number in each entry box should "
                               "be between 0 - 255 or does not fit into "
                               "any IP class type.");
                return SNMP_ERR_GENERR;
            }

            strcpy ( g_xCmMsg.uxData.xStunCfg.acStunServer, cStunServerAddr);
            g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
            g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_STUN;
            g_xCmMsg.ucChannel = 0;

            if (IFX_CM_SendDataToCM(&g_xCmMsg) != IFX_CM_SUCCESS)
            {
        	    snmp_log(LOG_ERR, "ifxStunServerAddr: Cant send Data to CM.\n");
                return SNMP_ERR_GENERR;
            }
        }

        return SNMP_ERR_NOERROR;
    }
    else
    {
        ifxStun_create_context();
        winfo.data      = (void *)&cStunServerAddr;
        winfo.data_size = strlen(cStunServerAddr);
        winfo.type      = ASN_OCTET_STR;
        winfo.flags     = HELPER_FIXED_SIZE;
        winfo.max_size  = strlen(cStunServerAddr);

        return (ifx_helper(handler, reginfo, reqinfo, requests, &winfo));
    }
}
