/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxForeignKeyIdx_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.7 2003/04/08 14:57:04 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/watcher.h>
#include "ifxForeignKeyIdx_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static uint32               unSessionIdx = 0;
static x_IFX_CM_Msg         g_xCmMsg;
netsnmp_helper_info         winfo;

void *
ifxForeignKeyIdx_create_context()
{
    memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

   	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	g_xCmMsg.ucInfoType = IFX_CM_RTP_MIB_CFG;
	g_xCmMsg.ucChannel = 0;
	g_xCmMsg.uxData.xRtpMibCfg.ucTableType = IFX_CM_RTP_SESSION_TABLE;

    if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR,"ifxForeignKeyIdx: Fail to receive data from CM\n");
    }

    unSessionIdx = g_xCmMsg.uxData.xRtpMibCfg.ucNoOfRows;
}

/** Initializes the ifxForeignKeyIdx module */
void
init_ifxForeignKeyIdx(void)
{
    static oid      ifxForeignKeyIdx_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 2, 1, 0 };

    DEBUGMSGTL(("ifxForeignKeyIdx", "Initializing\n"));

    netsnmp_register_instance(netsnmp_create_handler_registration
                             ("ifxForeignKeyIdx", A_get_ifxForeignKeyIdx,
                              ifxForeignKeyIdx_oid,
                              OID_LENGTH(ifxForeignKeyIdx_oid),
                              HANDLER_CAN_RONLY));

    ifxForeignKeyIdx_create_context();
}

int
A_get_ifxForeignKeyIdx(netsnmp_mib_handler *handler,
                      netsnmp_handler_registration *reginfo,
                      netsnmp_agent_request_info *reqinfo,
                      netsnmp_request_info *requests)
{
    switch(reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER, 
                (u_char *) &unSessionIdx, 
                sizeof(unSessionIdx));
            break;

        default:
            return SNMP_ERR_GENERR;
    }
    return SNMP_ERR_NOERROR;
}
