/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : RTP MIB
 *        Creator : Sharon Tseng
 *        File    : rtpSenderTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 12-May-2005
 *        Ref. Doc: RFC 2959
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "rtpSenderTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static unsigned int         nEntryNum = 0;
static x_IFX_CM_Msg         xCmMsg;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
 */
void *
ifxGetRtpTxCount()
{
    /* printf("**** ifxGetRtpTxCount ****\n"); */
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));
    memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_RTP_MIB_CFG;
	xCmMsg.ucChannel = 0;
	xCmMsg.uxData.xRtpMibCfg.ucTableType = IFX_CM_RTP_TX_TABLE;

    if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR, "Fail to receive data from CM\n");
        return NULL;
    }

    nEntryNum = xCmMsg.uxData.xRtpMibCfg.ucNoOfRows;

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_CM_RTP_TX_TABLE;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(RTPTXENTRY_S *);
        xMibMsg.nSize = sizeof(RTPTXENTRY_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
rtpSenderTable_set_indexes(RTPTXENTRY_S *datainfo,
                           netsnmp_variable_list *put_index_data)
{
    /* printf("**** rtpSenderTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* rtpSessionIndex */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index,
                       sizeof(datainfo->index));

    /* rtpSenderSSRC */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->uiSenderSSRC,
                       sizeof(datainfo->uiSenderSSRC) );

    return put_index_data;
}

RTPTXENTRY_S  **
rtpSenderTable_get_data(void)
{
    int              i = 0;
    unsigned int     net;
    unsigned char    addr[MAX_DATA_LEN];

    ifxGetRtpTxCount();

    for ( i = 0; i < nEntryNum; i++)
    {
        memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	xCmMsg.ucInfoType = IFX_CM_RTP_MIB_CFG;
    	xCmMsg.ucChannel = 0;
    	xCmMsg.uxData.xRtpMibCfg.ucTableType = IFX_CM_RTP_TX_TABLE;

        if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR, "Fail to receive data from CM\n");
            return NULL;
        }

        pstRtpTxCfg[i]->index = i;

        strcpy (pstRtpTxCfg[i]->rtpSenderCNAME,
                xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].acSenderCNAME);

        memset (addr, 0x00, MAX_DATA_LEN);
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].uiSenderIpAddr;
        sprintf(addr, "%d.%d.%d.%d",
                (net >> 24) & 0xff,
                (net >> 16) & 0xff,
                (net >> 8) & 0xff,
                (net & 0xff));
        strcpy (pstRtpTxCfg[i]->rtpSenderAddr, addr);

        pstRtpTxCfg[i]->uiSenderSSRC = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].uiSenderSSRC;

        pstRtpTxCfg[i]->rtpSenderPackets = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].ulSenderPackets;

        pstRtpTxCfg[i]->rtpSenderOctets = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].ulSenderOctets;

        strcpy (pstRtpTxCfg[i]->rtpSenderTool,
                xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].acSenderTool);

        pstRtpTxCfg[i]->rtpSenderSRs = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].uiSenderSRs;

        pstRtpTxCfg[i]->rtpSenderSRTime = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].uiSenderSRTime;

        pstRtpTxCfg[i]->rtpSenderPT = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].iSenderPT;

        pstRtpTxCfg[i]->rtpSenderStartTime = 
            xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axTxTable[0].uiSenderStartTime;
    }
}

/** returns the first data point within the rtpSenderTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
rtpSenderTable_get_first_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** rtpSenderTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    rtpSenderTable_get_data();

    if (!pstRtpTxCfg)
    {
        snmp_log(LOG_ERR, "rtpSenderTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstRtpTxCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return rtpSenderTable_set_indexes(pstRtpTxCfg[*position],
                                      put_index_data);
}

/** functionally the same as rtpSenderTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
rtpSenderTable_get_next_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    /* printf("**** rtpSenderTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetRtpTxCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstRtpTxCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return rtpSenderTable_set_indexes(pstRtpTxCfg[*position],
                                      put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
rtpSenderTable_create_data_context(netsnmp_variable_list * index_data)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
rtpSenderTable_commit_row(void **my_data_context, int new_or_del)
{
    snmp_log(LOG_ERR, "rtpSenderTable: Can\'t commit data.");
    return SNMP_ERR_NOERROR;
}

/*
 * User-defined data access functions (per column) for data in table rtpSenderTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** get_rtpSenderCNAME: return a data pointer to the data for the rtpSenderCNAME column and set
         ret_len to its proper size in bytes. */
char   *
get_rtpSenderCNAME(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->rtpSenderCNAME);
    return (char *) &datainfo->rtpSenderCNAME;
}

/** get_rtpSenderAddr: return a data pointer to the data for the rtpSenderAddr column and set
         ret_len to its proper size in bytes. */
unsigned char           *
get_rtpSenderAddr(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->rtpSenderAddr);
    return (unsigned char *) &datainfo->rtpSenderAddr;
}

/** get_rtpSenderPackets: return a data pointer to the data for the rtpSenderPackets column and set
         ret_len to its proper size in bytes. */
uint64            *
get_rtpSenderPackets(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderPackets);
    return &datainfo->rtpSenderPackets;
}

/** get_rtpSenderOctets: return a data pointer to the data for the rtpSenderOctets column and set
         ret_len to its proper size in bytes. */
uint64            *
get_rtpSenderOctets(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderOctets);
    return &datainfo->rtpSenderOctets;
}

/** get_rtpSenderTool: return a data pointer to the data for the rtpSenderTool column and set
         ret_len to its proper size in bytes. */
char   *
get_rtpSenderTool(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->rtpSenderTool);
    return (char *) &datainfo->rtpSenderTool;
}

/** get_rtpSenderSRs: return a data pointer to the data for the rtpSenderSRs column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSenderSRs(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderSRs);
    return &datainfo->rtpSenderSRs;
}

/** get_rtpSenderSRTime: return a data pointer to the data for the rtpSenderSRTime column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSenderSRTime(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderSRTime);
    return &datainfo->rtpSenderSRTime;
}

/** get_rtpSenderPT: return a data pointer to the data for the rtpSenderPT column and set
         ret_len to its proper size in bytes. */
int           *
get_rtpSenderPT(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderPT);
    return &datainfo->rtpSenderPT;
}

/** get_rtpSenderStartTime: return a data pointer to the data for the rtpSenderStartTime column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSenderStartTime(void *data_context, size_t * ret_len)
{
    RTPTXENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSenderStartTime);
    return &datainfo->rtpSenderStartTime;
}
